use super::ListNode;

struct Solution;

impl Solution {
    pub fn add_two_numbers(l1: Option<Box<ListNode>>, l2: Option<Box<ListNode>>) -> Option<Box<ListNode>> {

        let mut l1 = &l1;
        let mut l2 = &l2;
        let mut carry: i32 = 0;
        let mut res = ListNode::new(0);
        let  mut cur = &mut res;

        while l1.is_some() || l2.is_some() || carry > 0 {
            let mut sum: i32 = carry;
            if let Some(node1) = l1 {
                sum += node1.val;
                l1 = &node1.next;
            }

             if let Some(node2) = l2 {
                sum += node2.as_ref().val;
                l2 = &node2.next;
            }

            carry = sum / 10;

            cur.next = Some(Box::new(ListNode::new(sum % 10)));


            cur = cur.next.as_mut().unwrap();

        }

        res.next
    }
}

#[cfg(test)]
mod tests {

    use crate::solutions::{to_list, to_vec};

    use super::*;

    #[test]
    fn test_case_1() {
        let v1 = vec![2, 4, 3];
        let v2 = vec![5, 6, 4];
        let l1 = to_list(v1);
        let l2 = to_list(v2);

        let l3 = Solution::add_two_numbers(l1, l2);
        let v3 = to_vec(l3);
        let expect = vec![7,0,8];
        assert_eq!(v3, expect);

    }
}