struct Solution;

impl Solution {
    pub fn add_binary(a: String, b: String) -> String {
        let a: Vec<char> = a.chars().rev().collect();
        let b: Vec<char> = b.chars().rev().collect();
        let mut ans = vec![];
        let l = a.len().max(b.len());
        let mut carry = '0';
        for i in 0..l {
            let &c1 = a.get(i).unwrap_or(&'0');
            let &c2 = b.get(i).unwrap_or(&'0');
            match (c1, c2) {
                ('0', '0') => {
                    ans.push(carry);
                    carry = '0';
                }
                ('0', '1') | ('1', '0') if carry == '0' => ans.push('1'),
                ('0', '1') | ('1', '0') if carry == '1' => {
                    ans.push('0');
                    carry = '1';
                }
                ('1', '1') => {
                    ans.push(carry);
                    carry = '1';
                }
                _ => unreachable!(),
            }
        }
        if carry == '1' {
            ans.push('1');
        }
        ans.reverse();
        ans.iter().collect::<String>()
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let a = "11".to_string();
        let b = "1".to_string();
        let res = Solution::add_binary(a, b);
        assert_eq!(res, "100");
    }

    #[test]
    fn test_case_2() {
        let a = "1010".to_string();
        let b = "1011".to_string();
        let res = Solution::add_binary(a, b);
        assert_eq!(res, "10101");
    }
}
