struct Solution;

impl Solution {
    pub fn my_sqrt(x: i32) -> i32 {
        let x = x as i64;
        match x {
            0 => return 0,
            1 | 2 => return 1,
            _ => {
                let mut left: i64 = 1;
                let mut right: i64 = (x / 2) + 1;
                while left <= right {
                    let mid = (left + right) / 2;
                    if mid * mid == x as i64{
                        return mid as i32;
                    }
                    if mid * mid < x && (mid+1) * (mid+1) > x {
                        return mid as i32;
                    }

                    if mid * mid < x {
                        left = mid + 1;
                    } else {
                        right = mid - 1;
                    }
                }

            },
        }
        0
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_my_sqrt1() {
        let x = 4;
        let res = Solution::my_sqrt(x);
        assert_eq!(res, 2);

    }

    #[test]
    fn test_my_sqrt2() {
        let x = 8;
        let res = Solution::my_sqrt(x);
        assert_eq!(res, 2);

    }
    #[test]
    fn test_my_sqrt3() {
        let x = 2147395599;
        let res = Solution::my_sqrt(x);
        assert_eq!(res, 46339);

    }

}