struct Solution;

impl Solution {
    pub fn combination_sum(candidates: Vec<i32>, target: i32) -> Vec<Vec<i32>> {
        let mut res = vec![];
        let mut cur = vec![];
        Self::bt(&candidates[..], target, &mut cur, &mut res);

        res
    }

    fn bt(candidates: &[i32], target: i32, cur: &mut Vec<i32>, res: &mut Vec<Vec<i32>>) {
        if target < 0 {
            return;
        }
        if target == 0 {
            res.push(cur.to_vec());
            return;
        }

        for (i, &n) in candidates.iter().enumerate() {
            cur.push(n);
            Self::bt(&candidates[i..], target - n, cur, res);
            cur.pop();
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use std::collections::HashSet;

    #[test]
    fn test_combination_sum() {
        assert_eq!(
            Solution::combination_sum(vec![2, 3, 6, 7], 7),
            vec![vec![2, 2, 3], vec![7]]
        );
        assert_eq!(
            Solution::combination_sum(vec![2, 3, 5], 8),
            vec![vec![2, 2, 2, 2], vec![2, 3, 3], vec![3, 5]]
        );
    }

    #[test]
    fn test_hashset() {
        let v1 = vec![1, 2, 3];
        let v2 = vec![1, 2, 3];
        let mut s = HashSet::new();
        s.insert(v1);
        s.insert(v2);
        assert_eq!(s.len(), 1);
    }
}
