struct Solution;

// f(n) = max(f(n-1)+nums[n], nums[n])
// f(n): 包含这个元素的连续数字的最大和
impl Solution {
    pub fn max_sub_array(nums: Vec<i32>) -> i32 {
        let n = nums.len();
        let mut dp_i = nums[0];
        let mut ans = dp_i;
        for i in 1..n {
            dp_i = nums[i].max(dp_i + nums[i]);
            ans = ans.max(dp_i);
        }
        ans
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let nums = vec![-2, 1, -3, 4, -1, 2, 1, -5, 4];
        let res = Solution::max_sub_array(nums);
        assert_eq!(res, 6);
    }

    #[test]
    fn test_case_2() {
        let nums = vec![5, 4, -1, 7, 8];
        let res = Solution::max_sub_array(nums);
        assert_eq!(res, 23);
    }
}
