struct Solution;

impl Solution {
    pub fn min_path_sum(grid: Vec<Vec<i32>>) -> i32 {
        let m = grid.len();
        let n = grid[0].len();
        let mut dp = vec![0; n];

        dp[0] = grid[0][0];
        for j in 1..n {
            dp[j] = grid[0][j] + dp[j - 1];
        }

        for i in 1..m {
            for j in 0..n {
                if j == 0 {
                    dp[0] += grid[i][0];
                } else {
                    dp[j] = dp[j - 1].min(dp[j]) + grid[i][j];
                }
            }
        }

        dp[n - 1]
    }
}

#[cfg(test)]
mod tests {

    use super::*;

    #[test]
    fn test_case_1() {
        let grid = vec![vec![1, 3, 1], vec![1, 5, 1], vec![4, 2, 1]];

        let res = Solution::min_path_sum(grid);
        assert_eq!(res, 7);
    }
}
