struct Solution;

impl Solution {
    pub fn unique_paths_with_obstacles(obstacle_grid: Vec<Vec<i32>>) -> i32 {
        let m = obstacle_grid.len();
        let n = obstacle_grid[0].len();

        let mut dp = vec![1; n];
        for i in 0..n {
            if obstacle_grid[0][i] == 1 {
                dp[i] = 0;
            } else if i == 0 {
                dp[i] = 1;
            } else {
                dp[i] = dp[i - 1];
            }
        }

        for i in 1..m {
            for j in 0..n {
                if obstacle_grid[i][j] == 1 {
                    dp[j] = 0;
                } else if j == 0 {
                    continue;
                } else {
                    dp[j] += dp[j - 1];
                }
            }
        }

        dp[n - 1]
    }
}

#[cfg(test)]
mod tests {

    use super::*;

    #[test]
    fn test_case_1() {
        let obstacle_grid = vec![vec![0, 0, 0], vec![1, 1, 0], vec![0, 0, 0]];
        let res = Solution::unique_paths_with_obstacles(obstacle_grid);
        assert_eq!(res, 1);
    }
}
