struct Solution;


impl Solution {
    pub fn four_sum(nums: Vec<i32>, target: i32) -> Vec<Vec<i32>> {
        let mut nums = nums;
        nums.sort();
        if nums.len() < 4 {
            return vec![];
        }
        let mut ans = vec![];
        for i in 0..nums.len()-3 {
            if i > 0 && nums[i] == nums[i-1] {
                continue;
            }
            for j in i+1..nums.len()-2 {
                if j > i+1 && nums[j] == nums[j-1] {
                    continue;
                }
                let mut k = j+1;
                let mut l = nums.len()-1;
                while k < l {
                    let sum = nums[i] as i64 + nums[j] as i64 + nums[k] as i64 + nums[l] as i64;
                    let target = target as i64;
                    if sum == target{
                        ans.push(vec![nums[i], nums[j], nums[k], nums[l]]);
                        k += 1;
                        l -= 1;
                        while k < l && nums[k] == nums[k-1] {
                            k += 1;
                        }
                        while k < l && nums[l] == nums[l+1] {
                            l -= 1;
                        }
                    } else if sum < target {
                        k += 1;
                    } else {
                        l -= 1;
                    }
                }
            }
        }
        ans

    }


}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn it_works() {
        assert_eq!(2 + 2, 4);
    }

    #[test]
    fn test_case_1() {
        let s = vec![1, 0, -1, 0, -2, 2];
        let res: Vec<Vec<i32>> = Solution::four_sum(s, 0).into_iter().map(|v| v.into()).collect();
        assert_eq!(res, vec![vec![-2, -1, 1, 2], vec![-2, 0, 0, 2], vec![-1, 0, 0, 1]]);
    }




}