use crate::solutions::ListNode;

struct Solution;

impl Solution {
    pub fn merge_k_lists(lists: Vec<Option<Box<ListNode>>>) -> Option<Box<ListNode>> {
        if lists.len() == 0 {
            return None;
        }
        let mut lists = lists;
        let mut l1 = lists.pop().unwrap();
        while lists.len() > 0 {
            let l2 = lists.pop().unwrap();
            l1 = Self::merge_two_lists(l1, l2);
        }
        // for n in 1..lists.len() {
        //     let l2 = lists.get(n).unwrap().clone();
        //     l1 = Self::merge_two_lists(l1, l2);
        // }
        l1
    }

    fn merge_two_lists(
        l1: Option<Box<ListNode>>,
        l2: Option<Box<ListNode>>,
    ) -> Option<Box<ListNode>> {
        match (l1, l2) {
            (None, None) => None,
            (Some(n), None) | (None, Some(n)) => {
                return Some(Box::new(ListNode {
                    val: n.val,
                    next: Self::merge_two_lists(n.next, None),
                }));
            }
            (Some(n1), Some(n2)) => {
                if n1.val < n2.val {
                    return Some(Box::new(ListNode {
                        val: n1.val,
                        next: Self::merge_two_lists(n1.next, Some(n2)),
                    }));
                } else {
                    return Some(Box::new(ListNode {
                        val: n2.val,
                        next: Self::merge_two_lists(Some(n1), n2.next),
                    }));
                }
            }
        }
    }
}

#[cfg(test)]
mod tests {
    use crate::solutions::{to_list, to_vec};

    use super::*;

    #[test]
    fn test_merge_k_lists() {
        let v1 = vec![1, 2, 3];
        let l1 = to_list(v1);
        let v2 = vec![4, 5, 6];
        let l2 = to_list(v2);
        assert_eq!(
            to_vec(Solution::merge_k_lists(vec![l1, l2])),
            vec![1, 2, 3, 4, 5, 6]
        );
    }
}
