use std::mem;

use crate::solutions::ListNode;

struct Solution;

impl Solution {
    #[allow(dead_code)]
    pub fn merge_two_lists(
        list1: Option<Box<ListNode>>,
        list2: Option<Box<ListNode>>,
    ) -> Option<Box<ListNode>> {
        let mut l1 = list1;
        let mut l2 = list2;
        let mut dummy = None;
        let mut p_next = &mut dummy;

        while l1.is_some() && l2.is_some() {
            let lone = &mut l1;
            let ltwo = &mut l2;
            let l = if lone.as_ref().unwrap().val < ltwo.as_ref().unwrap().val {
                lone
            } else {
                ltwo
            };

            mem::swap(p_next, l);
            mem::swap(l, &mut p_next.as_mut().unwrap().next);
            p_next = &mut p_next.as_mut().unwrap().next;
        }

        mem::swap(p_next, if l1.is_none() { &mut l2 } else { &mut l1 });
        dummy
    }

    #[allow(dead_code)]
    pub fn merge_two_lists2(
        l1: Option<Box<ListNode>>,
        l2: Option<Box<ListNode>>,
    ) -> Option<Box<ListNode>> {
        let mut res = ListNode::new(-1);

        {
            let mut cur = &mut res.next;
            let mut ll1 = l1;
            let mut ll2 = l2;

            while ll1.is_some() || ll2.is_some() {
                if !ll1.is_some() {
                    let val = ll2.as_mut().unwrap().val;
                    *cur = Some(Box::new(ListNode::new(val)));
                    ll2 = ll2.unwrap().next;
                    cur = &mut cur.as_mut().unwrap().next;
                    continue;
                }
                if !ll2.is_some() {
                    let val = ll1.as_mut().unwrap().val;
                    *cur = Some(Box::new(ListNode::new(val)));
                    ll1 = ll1.unwrap().next;
                    cur = &mut cur.as_mut().unwrap().next;
                    continue;
                }

                let val1 = ll1.as_mut().unwrap().val;
                let val2 = ll2.as_mut().unwrap().val;
                if val1 < val2 {
                    *cur = Some(Box::new(ListNode::new(val1)));
                    ll1 = ll1.unwrap().next;
                } else {
                    *cur = Some(Box::new(ListNode::new(val2)));
                    ll2 = ll2.unwrap().next;
                }
                cur = &mut cur.as_mut().unwrap().next;
            }
        }

        return res.next;
    }

    #[allow(dead_code)]
    pub fn merge_two_lists3(
        l1: Option<Box<ListNode>>,
        l2: Option<Box<ListNode>>,
    ) -> Option<Box<ListNode>> {
        match (l1, l2) {
            (None, None) => None,
            (Some(n), None) | (None, Some(n)) => Some(n),
            (Some(l1), Some(l2)) => {
                if l1.val >= l2.val {
                    Some(Box::new(ListNode {
                        val: l2.val,
                        next: Solution::merge_two_lists(Some(l1), l2.next),
                    }))
                } else {
                    Some(Box::new(ListNode {
                        val: l1.val,
                        next: Solution::merge_two_lists(l1.next, Some(l2)),
                    }))
                }
            }
        }
    }
}
