struct Solution;
use crate::solutions::ListNode;

impl Solution {
    pub fn reverse_between(head: Option<Box<ListNode>>, left: i32, right: i32) -> Option<Box<ListNode>> {
        let mut dummy = Some(Box::new(
            ListNode {
                val: -1,
                next: head,
            }
        ));
        let mut before = &mut dummy;
        for _ in 1..left {
            before = &mut before.as_mut().unwrap().next;
        }
        let mut node = before.as_mut().unwrap().next.take();
        let mut node2 = node.as_mut().unwrap().next.take();

        for _ in left..right {
            let node3 = node2.as_mut().unwrap().next.take();
            node2.as_mut().unwrap().next = node;
            node = node2;
            node2 = node3;

        }

        let mut rev_tail = &mut node;
        for _ in left..right {
            rev_tail = &mut rev_tail.as_mut().unwrap().next;
        }

        rev_tail.as_mut().unwrap().next = node2;
        before.as_mut().unwrap().next = node;

        dummy.unwrap().next
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{to_list, to_vec};

    #[test]
    fn test_reverse_between() {
        let head = to_list(vec![1,2,3,4,5]);
        let left = 2;
        let right = 4;
        let res = Solution::reverse_between(head, left, right);
        assert_eq!(to_vec(res), vec![1,4,3,2,5]);

    }
}