struct Solution;

impl Solution {
    pub fn spiral_order(matrix: Vec<Vec<i32>>) -> Vec<i32> {
        let direction: Vec<(i32, i32)> = vec![(0, 1), (1, 0), (0, -1), (-1, 0)];
        let mut ans = vec![];
        let mut visited = std::collections::HashSet::<(usize, usize)>::new();

        let m = matrix.len();
        let n = matrix[0].len();
        let total = m * n;
        let (mut i, mut j) = (0, 0);
        let mut cur_direction: usize = if n > 1 { 0 } else { 1 };
        ans.push(matrix[0][0]);
        visited.insert((i, j));
        for _ in 1..total {
            let (ii, jj): (i32, i32) = direction[cur_direction];
            i = (i as i32 + ii) as usize;
            j = (j as i32 + jj) as usize;
            println!("i: {}, j: {}, ii: {}, jj: {}", i, j, ii, jj);

            ans.push(matrix[i][j]);
            cur_direction = Self::get_direction(i, j, m, n, cur_direction, &visited);
            visited.insert((i, j));
        }

        ans
    }

    fn get_direction(
        i: usize,
        j: usize,
        m: usize,
        n: usize,
        pre_idx: usize,
        visited: &std::collections::HashSet<(usize, usize)>,
    ) -> usize {
        if pre_idx == 0 && (j == n - 1 || visited.contains(&(i, j + 1))) {
            return 1;
        } else if pre_idx == 1 && (i == m - 1 || visited.contains(&(i + 1, j))) {
            return 2;
        } else if pre_idx == 2 && (j == 0 || visited.contains(&(i, j - 1))) {
            return 3;
        } else if pre_idx == 3 && (i == 0 || visited.contains(&(i - 1, j))) {
            return 0;
        }

        pre_idx
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case1() {
        let matrix = vec![vec![1, 2, 3, 4], vec![5, 6, 7, 8], vec![9, 10, 11, 12]];
        let res = Solution::spiral_order(matrix);
        assert_eq!(res, vec![1, 2, 3, 4, 8, 12, 11, 10, 9, 5, 6, 7]);
    }
    #[test]
    fn test_case2() {
        let matrix = [[1, 2, 3].to_vec(), [4, 5, 6].to_vec(), [7, 8, 9].to_vec()].to_vec();

        let res = Solution::spiral_order(matrix);
        assert_eq!(res, [1, 2, 3, 6, 9, 8, 7, 4, 5].to_vec());
    }

    #[test]
    fn test_case3() {
        let matrix = vec![vec![3], vec![2]];
        let res = Solution::spiral_order(matrix);
        assert_eq!(res, [3, 2].to_vec());
    }
}
