struct Solution;

impl Solution {
    pub fn generate_matrix(n: i32) -> Vec<Vec<i32>> {
        let mut ans = vec![vec![0; n as usize]; n as usize];
        let mut visited = vec![vec![false; n as usize]; n as usize];
        let mut cur = (0, 1);
        let total = n * n;
        let (mut x, mut y) = (0, 0);

        for i in 0..total {
            visited[x as usize][y as usize] = true;
            ans[x as usize][y as usize] = i + 1;
            cur = Self::get_next(x, y, n, cur, &visited);
            x += cur.0;
            y += cur.1;
        }

        ans
    }

    fn get_next(x: i32, y: i32, n: i32, cur: (i32, i32), visited: &Vec<Vec<bool>>) -> (i32, i32) {
        match cur {
            (0, 1) if y == n - 1 || visited[x as usize][y as usize + 1] => (1, 0),
            (1, 0) if x == n - 1 || visited[x as usize + 1][y as usize] => (0, -1),
            (0, -1) if y == 0 || visited[x as usize][y as usize - 1] => (-1, 0),
            (-1, 0) if visited[x as usize - 1][y as usize] => (0, 1),
            (_, _) => cur,
        }
    }
}

#[cfg(test)]
mod tests {

    use super::*;
    #[test]
    fn test_case1() {
        let res = Solution::generate_matrix(3);
        println!("{:?}", res);
    }
}
