struct Solution;

impl Solution {
    pub fn next_permutation(nums: &mut Vec<i32>) {
        if nums.len() == 1 {
            return;
        }
        Self::helper(nums, 0, nums.len());
    }

    fn helper(nums: &mut Vec<i32>, s: usize, e: usize) -> bool {
        let mut is_ans = false;
        if e - s == 2 {
            if nums[s] < nums[s + 1] {
                is_ans = true;
            } else {
                is_ans = false;
            }
            nums.swap(s, s + 1);

            return is_ans;
        }

        let res = Self::helper(nums, s + 1, e);
        // println!("~~~nums: {:?}, s: {}, e: {}, res: {}", nums, s, e, res);
        if res {
            return true;
        } else {
            // 找到s+1..e中的元素比nums[s]大的一种
            for i in s + 1..e {
                if nums[i] > nums[s] {
                    nums.swap(i, s);
                    is_ans = true;
                    break;
                }
            }
            if !is_ans {
                let tmp = nums[s];
                for i in s + 1..e {
                    nums[i - 1] = nums[i]
                }
                nums[e - 1] = tmp;
            }
        }

        // println!("nums: {:?}, s: {}, e: {}", nums, s, e);

        is_ans
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_next_permutation() {
        let mut nums = vec![1, 2, 3];
        Solution::next_permutation(&mut nums);
        assert_eq!(nums, vec![1, 3, 2]);
    }

    #[test]
    fn test_next_permutation_2() {
        let mut nums = vec![3, 2, 1];
        Solution::next_permutation(&mut nums);
        assert_eq!(nums, vec![1, 2, 3]);
    }

    #[test]
    fn test_next_permutation_3() {
        let mut nums = vec![1, 1, 5];
        Solution::next_permutation(&mut nums);
        assert_eq!(nums, vec![1, 5, 1]);
    }
}
