struct Solution;

impl Solution {
    pub fn is_match(s: String, p: String) -> bool {
        let n1 = p.len();
        let n2 = s.len();
        let mut dp = vec![vec![false; n2 + 1]; n1 + 1];
        dp[0][0] = true;
        for i in 0..=n1 {
            let mut flag = false;
            for j in 0..=n2 {
                if dp[i][j] {
                    continue;
                }
                if i == 0 {
                    dp[i][j] = false;
                    continue;
                }
                if flag {
                    dp[i][j] = true;
                    continue;
                }
                if p.chars().nth(i - 1).unwrap() == '*' {
                    if dp[i - 1][j] || (j > 0 && dp[i - 1][j - 1]) {
                        dp[i][j] = true;
                        flag = true;
                    }
                } else if j > 0 && p.chars().nth(i - 1).unwrap() == '?'
                    || j > 0 && p.chars().nth(i - 1).unwrap() == s.chars().nth(j - 1).unwrap()
                {
                    if dp[i - 1][j - 1] {
                        dp[i][j] = true;
                    }
                }
            }
        }

        dp[n1][n2]
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    #[test]
    fn test_is_match() {
        assert_eq!(
            Solution::is_match("abcd".to_string(), "a*c?".to_string()),
            true
        );
    }

    #[test]
    fn test_is_match_1() {
        assert_eq!(
            Solution::is_match("abceb".to_string(), "*a*b".to_string()),
            true
        );
    }

    #[test]
    fn test_is_match_2() {
        assert_eq!(Solution::is_match("".to_string(), "****".to_string()), true);
    }
}
