use super::ListNode;

struct Solution;

impl Solution {
    pub fn remove_nth_from_end2(head: Option<Box<ListNode>>, n: i32) -> Option<Box<ListNode>> {
        let mut dummy = Box::new(ListNode {
            val: -1,
            next: head,
        });
        let mut right = dummy.clone();
        let mut left = dummy.as_mut();

        for _ in 0..n {
            right = right.next.unwrap();
        }

        while let Some(node) = right.next {
            right = node;
            left = left.next.as_mut().unwrap();
        }

        left.next = left.next.as_mut().unwrap().next.clone();

        dummy.next
    }

    pub fn remove_nth_from_end(head: Option<Box<ListNode>>, n: i32) -> Option<Box<ListNode>> {
        let mut dummy = Some(Box::new(ListNode {
            val: -1,
            next: head,
        }));

        let mut next = &mut dummy.clone();
        let mut cur = &mut dummy;

        for _ in 0..n {
            next = &mut next.as_mut().unwrap().next;
        }

        while next.as_ref().unwrap().next.is_some() {
            cur = &mut cur.as_mut().unwrap().next;
            next = &mut next.as_mut().unwrap().next;
        }

        let mut cur_node = cur.as_mut().unwrap();
        let next_node = cur_node.clone().next.unwrap();
        cur_node.next = next_node.next;

        let res = dummy.unwrap().next;

        res

        // dummy.as_ref().unwrap().next;
    }
}

#[cfg(test)]
mod tests {
    use crate::solutions::{to_list, to_vec};

    use super::*;

    #[test]
    fn test_case_1() {
        let v1 = vec![1, 2, 3, 4, 5];
        let n = 2;
        let head = to_list(v1).unwrap();
        let res = Solution::remove_nth_from_end(Some(head), n);
        let expected = to_vec(res);
        let v2 = vec![1, 2, 3, 5];
        assert_eq!(v2, expected);
    }

    #[test]
    fn test_case_2() {
        let v1 = vec![1, 2, 3, 4, 5];
        let n = 2;
        let head = to_list(v1).unwrap();
        let res = Solution::remove_nth_from_end2(Some(head), n);
        let expected = to_vec(res);
        let v2 = vec![1, 2, 3, 5];
        assert_eq!(v2, expected);
    }
}
