struct Solution;


impl Solution {
    pub fn three_sum_closest(nums: Vec<i32>, target: i32) -> i32 {
         if nums.len() <= 3 {
            return nums.into_iter().sum();
        }

        let mut nums = nums;
        nums.sort();

        let mut closest = nums[0] + nums[1] + nums[2];
        let mut min_diff = (closest - target).abs();

        let mut a = 0;

        while a < nums.len() - 2 {

            let mut b = nums.len() - 1;
            let mut c = a + 1;

            while c < b {
                let sum = nums[a] + nums[b] + nums[c];
                let diff = (sum - target).abs();

                if diff < min_diff {
                    closest = sum;
                    min_diff = diff;
                }

                if sum > target {
                    b -= 1;
                } else if sum < target {
                    c += 1;
                } else {
                    return closest
                }

            }

            a += 1;
        }

        closest

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let nums = vec![-1, 2, 1, -4];
        let target = 1;
        let res = Solution::three_sum_closest(nums, target);
        let expect = 2;
        assert_eq!(res, expect)
    }

    #[test]
    fn test_case_2() {
        let nums = vec![4,0,5,-5,3,3,0,-4,-5];
        let target = -2;
        let res = Solution::three_sum_closest(nums, target);
        let expect = -2;
        assert_eq!(res, expect)
    }

    #[test]
    fn test_case_3() {
        let nums = vec![-1, 2, 1, -4];
        let target = 1;
        let res = Solution::three_sum_closest(nums, target);
        let expect = 2;
        assert_eq!(res, expect)
    }
}