struct Solution;

use crate::solutions::TreeNode;
use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn sorted_array_to_bst(nums: Vec<i32>) -> Option<Rc<RefCell<TreeNode>>> {
        Solution::helper(&nums[..])

    }

    fn helper(nums: &[i32]) -> Option<Rc<RefCell<TreeNode>>> {
        let l = nums.len();
        if l == 1 {
            return Some(Rc::new(RefCell::new(TreeNode::new(nums[0]))));
        }
        if l == 0 {
            return None;
        }

        let mid = l / 2;
        let root = Rc::new(RefCell::new(TreeNode::new(nums[mid])));
        root.borrow_mut().left = Solution::helper(&nums[..mid]);
        if mid >= l-1 {
            root.borrow_mut().right = None;
        } else {
            root.borrow_mut().right = Solution::helper(&nums[mid+1..])
        }
        Some(root)
    }
}

#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{inorder_traversal};

    #[test]
    fn test_sorted_array_to_bst() {
        let nums = vec![-10, -3, 0, 5, 9];
        let root = Solution::sorted_array_to_bst(nums);
        let res = inorder_traversal(root);
        assert_eq!(res, vec![-10, -3, 0, 5, 9]);

    }

}