struct Solution;


use crate::solutions::TreeNode;

use std::rc::Rc;
use std::cell::RefCell;
impl Solution {
    pub fn path_sum(root: Option<Rc<RefCell<TreeNode>>>, target_sum: i32) -> Vec<Vec<i32>> {
        let mut res = vec![];
        let mut cur = vec![];

        Solution::helper(root, target_sum, &mut cur, &mut res);
        res
    }

    fn helper(root: Option<Rc<RefCell<TreeNode>>>, target_sum: i32, cur: &mut Vec<i32>, res: &mut Vec<Vec<i32>>) {
        if let Some(node) = root {
            let val = node.borrow().val;
            let next_target_sum = target_sum - val;
            cur.push(val);

            if node.borrow().left.is_none() && node.borrow().right.is_none() {
                if next_target_sum == 0 {
                    res.push(cur.clone());
                }
            } else {

                Solution::helper(node.borrow().left.clone(), next_target_sum, cur, res);
                Solution::helper(node.borrow().right.clone(), next_target_sum, cur, res);
            }

            cur.pop();

        }
    }
}


#[cfg(test)]
mod tests {
    use super::*;
    use crate::solutions::{vec_to_tree};

    #[test]
    fn test_path_sum() {
        let target_sum = 22;
        let nums = vec![Some(5),Some(4),Some(8),Some(11),None,Some(13),Some(4),Some(7),Some(2),None,None,Some(5),Some(1)];
        let root = vec_to_tree(nums);
        let res = Solution::path_sum(root, target_sum);
        assert_eq!(res, vec![vec![5,4,11,2]]);

    }
}