struct Solution;

impl Solution {
    pub fn is_valid(s: String) -> bool {
        let mut stack: Vec<char> = vec![];
        for (_, c) in s.char_indices() {
            if c == '}' || c == ')' || c == ']' {
                if let Some(top) = stack.pop() {
                    if top != Solution::get_pair(c) {
                        return false;
                    }
                } else {
                    return false;
                }
            } else {
                stack.push(c);
            }

        }
        if stack.len() != 0 { return false }
        true
    }

    fn get_pair(c: char) -> char {
        match c {
            '}' => '{',
            ']' => '[',
            ')' => '(',
            _ => '_',
        }
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let s = "()".to_string();
        let res = Solution::is_valid(s);
        assert_eq!(res, true);
    }

    #[test]
    fn test_case_2() {
        let s = "()[]{}".to_string();
        let res = Solution::is_valid(s);
        assert_eq!(res, true);
    }

    #[test]
    fn test_case_3() {
        let s = "(]".to_string();
        let res = Solution::is_valid(s);
        assert_eq!(res, false);
    }
}
